package Gear::Remotes::File;

use strict;
use warnings;

sub new {
    my $proto=shift;
    my $class=ref($proto) || $proto;
    my $self = {
	-file => '.gear/upstream/remotes',
	@_,
    };
    bless($self,$class);
    die "Gear::Remotes: File ".$self->{-file}." does not exist.\n" if not -e $self->{-file};
    return $self;
}

sub label {
    my $self=shift;
    return $self->{-file};
}

sub list {
    my ($self)=@_;
    my @list;
    my $fn;
    open ($fn, "git config --file $self->{-file} --list|") || die "can't open $self->{-file}: $!";
    local $_;
    while (<$fn>) {
	chomp;
	push @list, $_;
    }
    close($fn);
    #$self->{-list}=\@list;
    return @list;
}

sub unset_all {
    my $self=shift;
    my $success=1;
    foreach my $key (@_) {
	my $exit_code=system(qw/git config --unset-all/, $key);
	if ($exit_code!=0 and $exit_code!=5) {
	    warn q!warning: git config --unset-all !.$key,q! failed: !, $exit_code, "\n";
	    $success=0;
	}
    }
    return $success;
}

sub append {
    my ($self, $to)=@_;
    my $from=$self->{-file};
    `cat '$from' >> '$to'`;
}


1;
